    processor 6502
    include vcs.h
    include macro.h
    include music.h

; Compile switches

NTSC                    = 0
PAL                     = 1 
COMPILE_VERSION         = NTSC

; Equates

STRIPE_SIZE              = 8
ALIEN_STRIPES            = 11
LEFTBORDER               = 0
LEFTBORDER               = 0

; Variables

    SEG.U vars
    ORG $80

spritePointer1      ds 2
spritePointer2      ds 2
xPosAlienLeft       ds ALIEN_STRIPES
xPosAlienRight      ds ALIEN_STRIPES
xPosAlienLeftFloat  ds ALIEN_STRIPES
xPosAlienRightFloat ds ALIEN_STRIPES
frameCounter        ds 1
rnd                 ds 1
tempVar1            ds 1
tempVar3            ds 1

    SEG     Bank0
    ORG $F000

;#######################
;# MAIN SCREEN DISPLAY #
;#######################

; Start display kernel
Maindisplay
    LDY #ALIEN_STRIPES-1
    STY tempVar3
    STA WSYNC           
    STA VBLANK          ; Stop VBLANK

AlienStripe
    LDY tempVar3

    TYA
    ASL
    ASL
    ASL
    ASL
    ORA #$07
    STA COLUP0
    STA COLUP1
    STA COLUPF

    LDA xPosAlienLeft,Y
    SEC
    STA WSYNC                ;
.waitzone1
    SBC #$0F                 ;
    BCS .waitzone1           ; RESP loop
    EOR #$07                 ;
    ASL                      ;
    ASL                      ;
    ASL                      ;
    ASL                      ;
    STA HMP0
    STA RESP0

    SLEEP 40

    LDA xPosAlienRight,Y
    SEC
    STA WSYNC                ;
.waitzone2
    SBC #$0F                 ;
    BCS .waitzone2           ; RESP loop
    EOR #$07                 ;
    ASL                      ;
    ASL                      ;
    ASL                      ;
    ASL                      ;
    STA HMP1
    STA RESP1

    STA WSYNC
    STA HMOVE

    LDY #STRIPE_SIZE-1
StripeLine2
    LAX (spritePointer2),Y
    LDA (spritePointer1),Y
    STA WSYNC
    STA GRP0
    STX GRP1
    LDA #%00101010
    STA PF2
    SLEEP 47
    DEY
    BPL StripeLine2
    LDA #$00
    STA PF2
    STA GRP0
    STA GRP1
    DEC tempVar3
    BMI DoTorpedoStripe
    JMP AlienStripe
DoTorpedoStripe
    JMP Overscan

;########################
;# CARTRIDGE MAIN ENTRY #
;########################

Start
    CLEAN_START

    LDA #$01
    STA CTRLPF

    SET_POINTER spritePointer1, alien
    SET_POINTER spritePointer2, alien
 
    LDX #ALIEN_STRIPES-1
Initaliens
    JSR Random
    AND #$1F
    STA xPosAlienLeft,X
    JSR Random
    AND #$1F
    ORA #$80
    STA xPosAlienRight,X
    DEX
    BPL Initaliens

; Main Program Loop

NEWSCREEN
    VERTICAL_SYNC

; Set VBLANK timer
    IF COMPILE_VERSION = PAL
        LDA #73
    ELSE
        LDA #43
    ENDIF
    STA TIM64T

VBLANKLOOP
    LDA INTIM
    BNE VBLANKLOOP  ; WAIT FOR VBLANK TIMER
    JMP Maindisplay

Overscan

    LDX #59
Burn
    STA WSYNC
    DEX
    BPL Burn

; Set Overscan timer
    IF COMPILE_VERSION = PAL
        LDA #65
    ELSE
        LDA #36
    ENDIF
    STA TIM64T

; Frame Stuff
    JSR Random
    INC frameCounter

OVERSCANLOOP:
    LDA INTIM
    BNE OVERSCANLOOP    ; WAIT FOR OVERSCAN TIMER
    STA WSYNC       ; FINISH WAITING FOR THE CURRENT LINE

    JMP NEWSCREEN


;-----------------------------------------------------------
;ITERATE A RANDOM VALUE
;-----------------------------------------------------------

Random
    LDA rnd
    BNE .skipInit
    LDA #$FF
.skipInit:
    ASL
    ASL
    ASL
    EOR rnd
    ASL
    ROL rnd
    RTS

alien
    .byte %00100100 
    .byte %01000010
    .byte %00111100
    .byte %10100101
    .byte %11100111
    .byte %00111100
    .byte %00011000
    .byte %01100110

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start